SystemOrganization addCategory: #'SourceCity-OpenGL'!

NBExternalStructure variableByteSubclass: #GLCityStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLCityStructure class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 13:38'!
fieldsDesc
  ^ #( 
         float r;
         float g;
         float b;
         float a;
        )! !

NBExternalStructure variableByteSubclass: #GLDoubleVector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLDoubleVector class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 6/8/2012 11:10'!
fieldsDesc
  ^ #( 
         NBGLDouble x;
         NBGLDouble y;
         NBGLDouble z;  
        )! !

NBExternalStructure variableByteSubclass: #GLFloatRGBA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLFloatRGBA class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 16:13'!
fieldsDesc
  ^ #( 
         NBGLFloat r;
         NBGLFloat g;
         NBGLFloat b;  
	   NBGLFloat a;      
        )! !

NBExternalStructure variableByteSubclass: #GLFloatShinines
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLFloatShinines class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 16:13'!
fieldsDesc
  ^ #( 
         NBGLFloat  r;
        )! !

NBExternalStructure variableByteSubclass: #GLFloatVector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLFloatVector commentStamp: '<historical>' prior: 0!
For initializing x, y, z!

!GLFloatVector class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 16:14'!
fieldsDesc
  ^ #( 
         NBGLFloat x;
         NBGLFloat y;
         NBGLFloat z;  
        )! !

StandardWindow subclass: #SourceCityUI
	instanceVariableNames: 'window informationDisplay cityInformation sourceCityGL'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!SourceCityUI commentStamp: '<historical>' prior: 0!
I am the window where you can watch source City, i also have some buttons and stuff for documentation picking!

!SourceCityUI class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 6/24/2012 13:19'!
initialize: aSourceCityGL
	^self new sourceCityGL: aSourceCityGL! !

!SourceCityUI methodsFor: 'display' stamp: 'DouailleErwan 6/24/2012 19:42'!
addAll
	self addMorph: self sourceCityGL
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0.5));
		addMorph: self buildInformation
		fullFrame: (LayoutFrame fractions: (0@0.5 corner: 1@1)).! !

!SourceCityUI methodsFor: 'display' stamp: 'DouailleErwan 6/24/2012 19:49'!
buildInformation
	^(self newTitle: 'Picking information' for: (
		(self newTextEditorFor: self cityInformation
			getText: #contents
			setText: #contents:) 
		disable;minWidth: 100;
		minHeight: 50)
		).! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 6/24/2012 19:26'!
cityInformation
	^ cityInformation! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 6/24/2012 19:26'!
cityInformation: anObject
	cityInformation := anObject! !

!SourceCityUI methodsFor: 'display' stamp: 'DouailleErwan 6/25/2012 10:33'!
information
	^(self newTitle: 'Picking information' for: (
		(self newTextEditorFor: cityInformation
			getText: #contents
			setText: #contents:) 
		disable;minWidth: 100;
		minHeight: 50)
		).! !

!SourceCityUI methodsFor: 'initialize' stamp: 'DouailleErwan 6/25/2012 10:33'!
initialize
	super initialize.
	cityInformation := ValueHolder new contents: ''.! !

!SourceCityUI methodsFor: 'display' stamp: 'DouailleErwan 6/24/2012 19:27'!
menu! !

!SourceCityUI methodsFor: 'initialize' stamp: 'DouailleErwan 6/25/2012 10:56'!
openInWorld
	| container |
	self addAll.
	super openInWorld.
	self themeChanged;
		title: 'SourceCity';
		width: 700;
		height: 500! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 6/25/2012 10:33'!
sourceCityGL
	^ sourceCityGL! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 6/24/2012 19:44'!
sourceCityGL: anObject
	sourceCityGL := anObject! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 6/24/2012 19:12'!
window
	^ window! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 6/24/2012 19:12'!
window: anObject
	window := anObject! !

!NBGLDisplay methodsFor: '*SourceCity-OpenGL' stamp: 'DouailleErwan 5/22/2012 11:27'!
readPixel: aPoint

      |  x y pixel |
	pixel := ByteArray new: 4.

	x := aPoint x asInteger.
	y := aPoint y asInteger.
	
	"Copy pixels from buffer into a form"
	self gl flush;
		pixelStorei_pname: GL_PACK_SKIP_ROWS param: 0;
		pixelStorei_pname: GL_PACK_SKIP_PIXELS param: 0;
		
		readPixels_x: x
		y: y
		width: 1  
		height: 1  
		format: GL_BGRA_EXT 
		type:  GL_UNSIGNED_BYTE 
		pixels: pixel.

	^ pixel
	! !

GLViewportMorph subclass: #GLCity
	instanceVariableNames: 'rotationAngle textId xrot yrot zrot face top down xtran ytran ztran znumb ynumb xnumb grass model frameCount font frameStats start configuration lastMousePosition curveRenderer glyphCache pickingBuf displayForUI selectedElement informationDisplay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLCity commentStamp: '<historical>' prior: 0!
A GLCity is a class which display the city with OpenGL, this class use camera and key handler!

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 6/15/2012 13:20'!
applyCamera
	display gl translatef_x: xtran y: ytran z: ztran. 
	display gl  rotatef_angle: configuration cameraXPos x: 1 y: 0  z: 0. 
	display gl rotatef_angle: configuration cameraYPos x: 0 y: 1  z: 0. 
	display gl rotatef_angle: configuration cameraZPos x: 0 y: 0  z: 1. 
! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 6/7/2012 16:34'!
buildingColor: anArray color: aColor width: aWidthSelector

		display gl color3f_red: aColor red green: aColor green blue: aColor blue.
		self drawFace: anArray width: aWidthSelector.
		self drawBack: anArray width: aWidthSelector.
		self drawLeft: anArray width: aWidthSelector.
		self drawRight: anArray width: aWidthSelector.
		self drawDown: anArray width: aWidthSelector.
		self drawTop: anArray width: aWidthSelector.
		self drawBorder: anArray width: aWidthSelector.
	! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 6/7/2012 16:35'!
buildingPicking: anArray width: aWidthSelector building: building
	| x z y r g b id |

	id := building id.
	r := id bitAnd: 255.
	g := id >> 8 bitAnd: 255.  " id // (2^8) "
	b := id >>16 bitAnd: 255.
		
	display gl color3ub_red:  r green: g  blue:  b.
	
	self drawFace: anArray width: aWidthSelector.
	self drawBack: anArray width: aWidthSelector.
	self drawLeft: anArray width: aWidthSelector.
	self drawRight: anArray width: aWidthSelector.
	self drawDown: anArray width: aWidthSelector.
	self drawTop: anArray width: aWidthSelector.! !

!GLCity methodsFor: 'control' stamp: 'DouailleErwan 5/22/2012 14:44'!
captureKey: e

	(e keyString = '<left>')
		ifTrue:[ self rotateLeft].
	(e keyString  = '<down>')
		ifTrue:[self rotateDown].
	(e keyString  = '<up>')
		ifTrue:[self rotateTop].
	(e keyString  = '<right>')
		ifTrue:[self rotateRight].
	(e keyString  = '<Shift-right>')
		ifTrue:[self translateRight].
	(e keyString  = '<Shift-left>')
		ifTrue:[self translateLeft].
	(e keyString  = '<Shift-up>')
		ifTrue:[self translateTop].
	(e keyString  = '<Shift-down>')
		ifTrue:[self translateDown].
	(e keyString  = ' ')
		ifTrue:[self translateForward].
	(e keyString  = 'c' )
		ifTrue:[self translateBackward].! !

!GLCity methodsFor: 'control' stamp: 'DouailleErwan 6/22/2012 13:20'!
captureMouseDown: e
	| x y  pixel tmp |
	 x := (e position x) - self position x.
	 y := (e position y) - self position y.
	tmp :=0.
	displayForUI := true.
	self drawCity: model.
	display gl 
		disable: GL_MULTISAMPLE ;
		disable: GL_BLEND;
		disable: GL_POLYGON_SMOOTH;
		disable: GL_NORMALIZE;
		clearDepth: 1; 
	 	disable: GL_DEPTH_TEST;
		shadeModel: GL_FLAT;
		flush.
	pixel := display readPixel: x@y.	
	displayForUI := false.
	tmp := (pixel asInteger ).
	"Transcript cr;show: pixel asInteger hex.
	Transcript cr;show: pixel printString."
	tmp := (pixel at:1)*256 + (pixel at:2)*256 + (pixel at:3).
	(tmp = 16777215)
	ifTrue: [
		self selectedElement: nil.
		informationDisplay contents: ''.
		] 
	ifFalse: [
		self searchPickingInformation: tmp.
		].! !

!GLCity methodsFor: 'control' stamp: 'DouailleErwan 6/20/2012 11:27'!
captureMouseStillDown: e
	(self lastMousePosition x > (e position - self position) x)
		ifTrue: [self rotateLeft].
	(self lastMousePosition x < (e position - self position) x)
		ifTrue:[self rotateRight].
	(self lastMousePosition y < (e position - self position) y)
		ifTrue:[self rotateTop].
	(self lastMousePosition y > (e position - self position) y)
		ifTrue:[self rotateDown].
	self lastMousePosition: (e position - self position).! !

!GLCity methodsFor: 'accessing' stamp: 'DouailleErwan 5/3/2012 16:25'!
changeConfiguration: aCityConfiguration
	configuration := aCityConfiguration.
	model := configuration model.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 4/17/2012 17:25'!
city: anArrayStart to: anArrayEnd
	|gl|
	
	gl := display gl.
	gl enable: GL_TEXTURE_2D.
	
	gl bindTexture_target: GL_TEXTURE_2D texture: city. 			
	gl begin: GL_QUADS.
		
		self vertex: { anArrayStart first . anArrayStart second . anArrayStart third } texCoord: #(0 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayStart third } texCoord: #(1 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayEnd third } texCoord: #(1 1).
		self vertex: { anArrayStart first . anArrayStart second . anArrayEnd third } texCoord: #(0 1).

	gl end.
	! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/2/2012 15:06'!
cityColor: anArrayStart to: anArrayEnd color: aColor
	|gl|
	gl := display gl.	
	gl begin: GL_QUADS;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayEnd third;
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayEnd third;
	end.
	! !

!GLCity methodsFor: 'initialize' stamp: 'DouailleErwan 5/29/2012 10:56'!
default: aCityConfiguration
	configuration := aCityConfiguration.
	model := configuration model.
	xtran := 0.
	ytran := 30.
	ztran := -384.! !

!GLCity methodsFor: 'rendering' stamp: 'DouailleErwan 6/15/2012 13:28'!
disableOpenGLOption
	
	display gl 		
		disable: GL_MULTISAMPLE ;
		disable: GL_BLEND;
		disable: GL_POLYGON_SMOOTH;
		disable: GL_NORMALIZE;
		clearDepth: 1; 
	 	disable: GL_DEPTH_TEST;
		depthFunc: GL_LEQUAL;
		depthMask: true.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 4/17/2012 17:24'!
district: anArrayStart to: anArrayEnd
	|gl|
	gl := display gl.
	gl enable: GL_TEXTURE_2D.
	gl bindTexture_target: GL_TEXTURE_2D texture: district. 	
	gl begin: GL_QUADS.

		self vertex: { anArrayStart first . anArrayStart second . anArrayStart third } texCoord: #(0 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayStart third } texCoord: #(1 0).
		self vertex: { anArrayEnd first . anArrayStart second . anArrayEnd third } texCoord: #(1 1).
		self vertex: { anArrayStart first . anArrayStart second . anArrayEnd third } texCoord: #(0 1).
		
		self vertex: { anArrayStart first . anArrayEnd second . anArrayStart third } texCoord: #(0 0).
		self vertex: { anArrayStart first . anArrayEnd second . anArrayEnd third } texCoord: #(1 0).
		self vertex: { anArrayEnd first . anArrayEnd second . anArrayEnd third } texCoord: #(1 1).
		self vertex: { anArrayEnd first . anArrayEnd second . anArrayStart third } texCoord: #(0 1).

	gl end.	! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 6/7/2012 16:38'!
districtColor: anArrayStart to: anArrayEnd color: aColor
	|gl|
	gl := display gl.
	gl begin: GL_QUADS;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayEnd third;
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayEnd third;
	end.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 6/7/2012 16:40'!
districtPicking: anArrayStart to: anArrayEnd district: aDistrict
	|gl id r g b |

	id := aDistrict id.
	r := id bitAnd: 255.
	g := id >> 8 bitAnd: 255.  " id // (2^8) "
	b := id >>16 bitAnd: 255.
		
	display gl color3ub_red:  r green: g  blue:  b.
	gl := display gl.
	gl begin: GL_QUADS;
		color3ub_red:  r green: g  blue:  b;
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayEnd third;
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayEnd third;
	end.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 6/7/2012 16:39'!
districtPicking: anArrayStart to: anArrayEnd id: aColor
	|gl|
	gl := display gl.
	gl begin: GL_QUADS;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayEnd third;
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayEnd third;
	end.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 6/7/2012 16:32'!
drawBack: anArray width: aWidthSelector
	|gl x z y |
	gl := display gl.
	gl begin: GL_QUADS;
		vertex3d_x:  anArray first y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3d_x:  (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3d_x:  (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		vertex3d_x:  anArray first y: anArray second z: (anArray third)+aWidthSelector;
	end.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/11/2012 10:43'!
drawBorder: anArray 
	|gl|
	gl := display gl.
	gl begin: GL_LINES;

		color3f_red: 0 green: 0 blue: 0; 
		vertex3f_x: anArray first y: 0.1 z: anArray third;
		vertex3f_x: anArray first y: anArray second z: anArray third;
		
	end.
	! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/11/2012 11:22'!
drawBorder: anArray width: aWidthSelector
	|gl|
	gl := display gl.
	gl begin: GL_LINES;

		color3f_red: 0 green: 0 blue: 0; 
		vertex3f_x: anArray first y: 0.1 z: anArray third;
		vertex3f_x: anArray first y: anArray second z: anArray third;
		
		vertex3f_x: anArray first y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3f_x: anArray first y: anArray second z: (anArray third)+aWidthSelector;
		
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: anArray third;
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: anArray third;
		
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		
		vertex3f_x: anArray first y: 0.1 z: anArray third;
		vertex3f_x: anArray first y: 0.1 z: (anArray third)+aWidthSelector;
		
		vertex3f_x: anArray first y: anArray second z: anArray third;
		vertex3f_x: anArray first y: anArray second z: (anArray third)+aWidthSelector;
		
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: anArray third;
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: anArray third;
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
		
		vertex3f_x: anArray first y: anArray second z: anArray third;
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: anArray third;
		
		vertex3f_x: anArray first y: 0.1 z: anArray third;
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: anArray third;
		
		vertex3f_x: anArray first y: anArray second z: (anArray third)+aWidthSelector;
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		
		vertex3f_x: anArray first y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
		
	end.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 6/22/2012 13:21'!
drawBuilding: aDistrict gap: buildingGap x: x z: z dxSize: dxSize
	| bxSize bzSize zmax buildingColor |
	bxSize := x +1 .
	bzSize := z +1.
	zmax := 0.
	aDistrict buildings do: [:building |
		(dxSize < (bxSize+ (building width)))
		ifTrue: [
			bzSize := bzSize + zmax + buildingGap.
			bxSize := x + 1.
			].
		(zmax<(building width))
		ifTrue:[zmax := (building width)].
		(displayForUI)
		ifTrue: [self buildingPicking: { bxSize . (building height) . bzSize } width: (building width) building: building.]
		ifFalse: [
			buildingColor := building color.
			(self selectedElement == building)
			ifTrue: [buildingColor := Color white ].
				self buildingColor: { bxSize . (building height) . bzSize } color: buildingColor width: (building width)..
			].
		bxSize := bxSize + buildingGap + (building width).
	].
	^bzSize+zmax+1.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 6/15/2012 13:30'!
drawCity: anImporter
	self cityColor: {-1 . -0.1 . -1} to: (self drawDistrict: anImporter city gap: configuration districtGap) color: configuration cityColor.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 6/22/2012 13:21'!
drawDistrict:aCity gap: gap
	| dxSize x dzSize z maxdxSize maxdzSize bxSize bzSize buildingGap districtColor |
	x := 0.
	z := 0.
	buildingGap := configuration buildingGap.
	(configuration buildingGap < 1)
	ifTrue: [buildingGap := 1.] 
	ifFalse: [buildingGap := configuration buildingGap].
	maxdzSize := 0.
	maxdxSize := 0.
	aCity districts do:[:district |
		dxSize := x + ((district width) *buildingGap+1).
		dzSize := self drawBuilding: district gap: buildingGap x: x z: z dxSize: dxSize.
		(displayForUI)
		ifTrue: [self districtPicking: {x . 0.1 . z} to: {dxSize . 0.1 . dzSize} district: district.]
		ifFalse: [
			districtColor :=  configuration districtColor.
			(self selectedElement == district)
			ifTrue: [districtColor := Color white ].
			self districtColor: {x . 0.1 . z} to: {dxSize . 0.1 . dzSize} color: districtColor.
			].
		(maxdzSize < dzSize)
		ifTrue: [ maxdzSize := dzSize].
		x := dxSize + gap.
		( x > aCity width)
		ifTrue: [
			z := maxdzSize + gap.
			(maxdxSize<x)
			ifTrue: [maxdxSize := x+(dxSize - x).].
			x := 0.
		]
		ifFalse: [
			(maxdxSize<x)
			ifTrue: [maxdxSize := x.].
		].
	].
	^{maxdxSize+1 . 0 . maxdzSize+1}! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 6/7/2012 16:32'!
drawDown: anArray width: aWidthSelector
	| gl x z y |
	gl := display gl.
	gl enable: GL_NORMALIZE .
	gl begin: GL_QUADS;
		vertex3d_x:  anArray first y: 0.1 z: anArray third;
		vertex3d_x:  (anArray first)+aWidthSelector y: 0.1 z: anArray third;
		vertex3d_x:  (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3d_x:  anArray first y: 0.1 z: (anArray third)+aWidthSelector;
	end.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 6/7/2012 16:32'!
drawFace: anArray width: aWidthSelector
	| gl x z y |
	gl := display gl.
	gl begin: GL_QUADS;
		vertex3d_x: anArray first y: 0.1 z: anArray third;
		vertex3d_x: anArray first y: anArray second z: anArray third;
		vertex3d_x: (anArray first)+aWidthSelector y: anArray second z: anArray third;
		vertex3d_x: (anArray first)+aWidthSelector y: 0.1 z: anArray third;
	end.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 6/7/2012 16:31'!
drawLeft: anArray width: aWidthSelector
	| gl x z y |
	gl := display gl.
	gl begin: GL_QUADS;
		vertex3d_x:  (anArray first)+aWidthSelector y: 0.1 z: anArray third;
		vertex3d_x:  (anArray first)+aWidthSelector y: anArray second z: anArray third;
		vertex3d_x:  (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		vertex3d_x:  (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
	end.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 6/7/2012 16:30'!
drawRight: anArray width: aWidthSelector
	| gl x z y |
	gl := display gl.
	gl begin: GL_QUADS;
		vertex3d_x:  anArray first y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3d_x:  anArray first y: anArray second z: (anArray third)+aWidthSelector;
		vertex3d_x:  anArray first y: anArray second z: anArray third ;
		vertex3d_x:  anArray first y: 0.1 z: anArray third ;
	end.! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/23/2012 15:47'!
drawText: aString to: anArray
	| gl x |
	gl := display gl.
	curveRenderer ifNotNil: [  | g adv |
		gl color3f_red: 0 green:  0 blue: 0. 
		gl pushMatrix.
		gl scalef_x: 1000 y: 1000  z: 1.
		gl translatef_x: 0 y: 0  z: 0. 
		adv := 0.
		aString asString do:  [:ch |
			g := font at: ch.
			glyphCache renderGlyph: g.
			adv := adv + g advanceWidth.
			gl translatef_x: g advanceWidth y: 0 z:0.
		].
		gl popMatrix.
	].
	
! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 6/7/2012 16:33'!
drawTop: anArray width: aWidthSelector
	|gl x z y |
	gl := display gl.
	gl begin: GL_QUADS;
		vertex3d_x: anArray first y: anArray second z: anArray third ;
		vertex3d_x: anArray first y: anArray second z: (anArray third)+aWidthSelector;
		vertex3d_x: (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		vertex3d_x: (anArray first)+aWidthSelector y: anArray second z: anArray third ;
	end.! !

!GLCity methodsFor: 'rendering' stamp: 'DouailleErwan 6/15/2012 13:26'!
enableOpenGLOption
	
	display gl 		
		enable: GL_MULTISAMPLE ;
		enable: GL_BLEND;
		enable: GL_POLYGON_SMOOTH;
		enable: GL_NORMALIZE;
		clearDepth: 1; 
	 	enable: GL_DEPTH_TEST;
		shadeModel: GL_SMOOTH;
		hint_target: GL_LINE_SMOOTH_HINT mode: GL_FASTEST;
		hint_target: GL_POLYGON_SMOOTH_HINT mode: GL_FASTEST;
		hint_target: GL_PERSPECTIVE_CORRECTION_HINT mode: GL_NICEST;
		depthFunc: GL_LEQUAL;
		depthMask: true.		
	
	"WORK !!!!!!!!"
	"specular := GLFloatRGBA new.
	specular r: 1; g: 1;b: 1; a:1. 
	shinines:= GLFloatRGBA new.
	shinines r: 500. 	
	l_pos := GLFloatVector new.
	l_pos x: 0 ;y: 0;z: 0. 
	l_color := GLFloatRGBA new.
	l_color r: 1; g: 1;b: 1; a:1. 			
	lmodel_ambient := GLFloatRGBA new.
	lmodel_ambient r: 1;g: 1 ;b: 1; a:1."
	
	"fog_color := GLFloatRGBA new.
	fog_color r: 0.5; g: 0.5;b: 0.5; a:1. "
		
		"FOG"
		"enable: GL_FOG;
		fogi_pname: GL_FOG_MODE param: GL_EXP2;
		fogfv_pname: GL_FOG_COLOR params: fog_color;
		fogf_pname: GL_FOG_DENSITY param: 0.01;
		hint_target: GL_FOG_HINT mode: GL_DONT_CARE;
		fogf_pname: GL_FOG_START param: 1.0;
		fogf_pname: GL_FOG_END param: 5.0;"
		
		"LIGHT"
		"materialfv_face: GL_FRONT pname: GL_SPECULAR params: specular;
		materialfv_face: GL_FRONT pname: GL_SHININESS  params: shinines;
		lightfv_light: GL_LIGHT0 pname: GL_POSITION params: l_pos;
		lightfv_light: GL_LIGHT0 pname: GL_DIFFUSE params: l_color;
		lightfv_light: GL_LIGHT0 pname: GL_SPECULAR params: l_color;
		lightModelfv_pname: GL_LIGHT_MODEL_AMBIENT params: lmodel_ambient;
		enable: GL_LIGHTING;
		enable: GL_LIGHT0;	"
				
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 6/8/2012 11:04'!
gluLookAt_x: eyex y: eyey z: eyez center_x: centerx center_y: centery center_z: centerz up_x: upx up_y: upy up_z: upz
"
    float forward[3], side[3], up[3];
    GLfloat m[4][4];

    forward[0] = centerx - eyex;
    forward[1] = centery - eyey;
    forward[2] = centerz - eyez;

    up[0] = upx;
    up[1] = upy;
    up[2] = upz;

    normalize(forward);

    /* Side = forward x up */
    cross(forward, up, side);
    normalize(side);

    /* Recompute up as: up = side x forward */
    cross(side, forward, up);

    __gluMakeIdentityf(&m[0][0]);
    m[0][0] = side[0];
    m[1][0] = side[1];
    m[2][0] = side[2];

    m[0][1] = up[0];
    m[1][1] = up[1];
    m[2][1] = up[2];

    m[0][2] = -forward[0];
    m[1][2] = -forward[1];
    m[2][2] = -forward[2];

    glMultMatrixf(&m[0][0]);"
    display gl translated_x: eyex y: eyey z: eyez
! !

!GLCity methodsFor: 'control' stamp: 'DouailleErwan 6/20/2012 11:16'!
handleMouseMove: anEvent
	"System level event handling."
	anEvent wasHandled ifTrue:[^self]. "not interested"
	anEvent wasHandled: true.

	anEvent anyButtonPressed ifTrue: [
		self captureMouseStillDown: anEvent
		].
! !

!GLCity methodsFor: 'control' stamp: 'DouailleErwan 6/8/2012 09:57'!
hasKeyboardFocus
	^true.! !

!GLCity methodsFor: 'initialize' stamp: 'DouailleErwan 6/4/2012 12:25'!
initialize
	| fontPath |
	super initialize.
	lastMousePosition := Point x: 0 y:0.
	displayForUI := false.
	self on: #keyStroke send: #captureKey: to: self.
	self on: #mouseDown send: #captureMouseDown: to: self.
	fontPath := self platformDefaultFontsPath.	
	font := NBTTFontReader readFrom:  
		(FileStream readOnlyFileNamed: fontPath , 'Tahoma.ttf').
	! !

!GLCity methodsFor: 'session management' stamp: 'DouailleErwan 5/22/2012 14:41'!
initializeForNewSession
	super initializeForNewSession.
	"self loadText."
       curveRenderer := nil.
       (display gl isSupportedExtension: #GL_ARB_fragment_program ) ifTrue: [
               curveRenderer := NBGLCurveRenderer new gl: display gl.
               glyphCache := NBTTFontCache new initialize: curveRenderer.
       ]! !

!GLCity methodsFor: 'accessing' stamp: 'DouailleErwan 5/7/2012 14:22'!
lastMousePosition
	^lastMousePosition! !

!GLCity methodsFor: 'accessing' stamp: 'DouailleErwan 5/7/2012 14:22'!
lastMousePosition: aPoint
	lastMousePosition := aPoint! !

!GLCity methodsFor: 'session management' stamp: 'DouailleErwan 4/18/2012 14:33'!
loadText
       curveRenderer := nil.
       (display gl isSupportedExtension: #GL_ARB_fragment_program ) ifTrue: [
               curveRenderer := NBGLCurveRenderer new gl: display gl.
               glyphCache := NBTTFontCache new initialize: curveRenderer.
       ]! !

!GLCity methodsFor: 'initialize' stamp: 'DouailleErwan 6/10/2012 12:05'!
openInWorld
	|dock container win |
	"super openInWorld setLabel:'SourceCity'."
	self startStepping.
	self takeKeyboardFocus.
	win := StandardWindow new.
	informationDisplay := ValueHolder new contents: ''.
	container :=  (win newTitle: 'Documentation' for: (
							(win newTextEditorFor: informationDisplay
							getText: #contents
							setText: #contents:) disable;minWidth: 100;minHeight: 50)).
		win
			addMorph: self
			fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0.5));
			addMorph: container
			fullFrame: (LayoutFrame fractions: (0@0.5 corner: 1@1)).
		win
			themeChanged;
			title: 'SourceCity';
			openInWorld;
			width: 700;
			height: 500.! !

!GLCity methodsFor: 'rendering' stamp: 'DouailleErwan 6/15/2012 13:25'!
openglOption: aBoolean
	(aBoolean)
	ifTrue: [self enableOpenGLOption] 
	ifFalse: [self disableOpenGLOption]. ! !

!GLCity methodsFor: 'camera' stamp: 'douaille 4/7/2012 16:42'!
perspectiveFovY: fovY aspect: aspect zNear: zNear zFar: zFar
"Replaces gluPerspective. Sets the frustum to perspective mode.
// fovY     - Field of vision in degrees in the y direction
// aspect   - Aspect ratio of the viewport
// zNear    - The near clipping distance
// zFar     - The far clipping distance
 "
	| fW fH |
	fH := (fovY / (360 * Float pi)) tan * zNear.
	"fH = tan( fovY / 360 * pi ) * zNear;"
	fW := fH * aspect.
	display gl frustum_left: fW negated  right:  fW bottom: fH negated top: fH  zNear:  zNear zFar:   zFar! !

!GLCity methodsFor: 'session management' stamp: 'DouailleErwan 5/22/2012 14:41'!
platformDefaultFontsPath

	NativeBoost platformId == NativeBoostConstants win32PlatformId ifTrue: [
		^ 'C:\Windows\Fonts\'
		].
	NativeBoost platformId == NativeBoostConstants mac32PlaformId ifTrue: [
		^ '/Library/Fonts/'
		].
! !

!GLCity methodsFor: 'rendering' stamp: 'DouailleErwan 6/15/2012 13:29'!
render
	| gl |
	display bindRenderBuffers.
	self checkSession.
	gl := display gl.
	self openglOption: true.
	gl clearColor_red: configuration glBackground red green:  configuration glBackground green blue:  configuration glBackground blue alpha: 0;
		clear: GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT;
		matrixMode: GL_PROJECTION; 						
		loadIdentity.		
	self perspectiveFovY: 100.0 
			aspect: (self width /self height) asFloat 
			zNear:  0.1 zFar: 10000.0.
	gl matrixMode: GL_MODELVIEW;
		loadIdentity.	
	self applyCamera.
	self drawCity: model.
	gl flush.! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/29/2012 10:27'!
rotateDown

	configuration cameraXPos: (configuration cameraXPos + 3).
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/29/2012 10:28'!
rotateLeft

	configuration cameraYPos: (configuration cameraYPos + 3).
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/29/2012 10:28'!
rotateRight
	
	configuration cameraYPos: (configuration cameraYPos - 3).! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/29/2012 10:27'!
rotateTop
	configuration cameraXPos: (configuration cameraXPos - 3).! !

!GLCity methodsFor: 'control' stamp: 'DouailleErwan 6/18/2012 15:25'!
searchPickingInformation: aValue"
	model districtsPicking at: aValue 
		ifPresent: [ 
			selectedElement := model districtsPicking at: aValue.
			informationDisplay contents: selectedElement model asString, Character cr asString,Character cr asString,
				'Classes : ', selectedElement model classes size asString, Character cr asString,
				'City : ', selectedElement city model asString, Character cr asString.
			^ self.
			].
	model buildingsPicking at: aValue 
		ifPresent: [ 
			selectedElement := model buildingsPicking at: aValue.
			informationDisplay contents: selectedElement model asString, Character cr asString,Character cr asString,
				'Selectors : ', selectedElement model selectors size asString, Character cr asString,
				'VarInst : ', selectedElement model allInstVarNames size asString, Character cr asString,	
				'VarClass : ', selectedElement model allClassVarNames size asString, Character cr asString,Character cr asString,
				'District : ', selectedElement district model asString, Character cr asString,
				'City : ', selectedElement district city model asString, Character cr asString.
			^self
			] .
	selectedElement := nil.
	informationDisplay contents: 'unknow element'"! !

!GLCity methodsFor: 'stepping and presenter' stamp: 'DouailleErwan 4/23/2012 10:46'!
step
	self changed! !

!GLCity methodsFor: 'stepping and presenter' stamp: 'DouailleErwan 4/23/2012 10:46'!
stepTime
	^5! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/22/2012 14:45'!
translateBackward

	ztran := ztran - 3.
	
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/29/2012 15:15'!
translateDown

	ytran := ytran + 30.
	
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/29/2012 15:15'!
translateForward

	ztran := ztran + 30.
	
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/22/2012 14:45'!
translateLeft

	xtran := xtran - 3.
	
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/22/2012 14:45'!
translateRight

	xtran := xtran + 3.
	
	! !

!GLCity methodsFor: 'camera' stamp: 'DouailleErwan 5/22/2012 14:45'!
translateTop

	ytran := ytran - 3.
	
	! !

!GLCity methodsFor: 'drawing' stamp: 'DouailleErwan 5/22/2012 11:16'!
vertex: array

	display gl 
		vertex3d_x: array first y: array second  z: array third! !

GLViewportMorph subclass: #GLTest
	instanceVariableNames: 'rot model face top down grass xtran ytran ztran xrot yrot zrot znumb xnumb ynumb pickingBuf'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLTest commentStamp: '<historical>' prior: 0!
Doing some examples in OpenGL.!

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
applyCamera
	display gl translatef_x: xtran y: ytran z: ztran. 
	display gl  rotatef_angle: xrot x: 1 y: 0  z: 0. 
	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. 
	display gl rotatef_angle: yrot x: 0 y: 1  z: 0. 
! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/22/2012 15:02'!
cube_x: x y: y z: z
	|gl|
	
	gl := display gl.
	gl begin: GL_QUADS;
		pushMatrix;
		pushName: x;
		scalef_x: 3 y: 1 z: 1;
		color3f_red: 0 green: 0 blue: 1; 
		vertex3f_x: x y: 0  z: z; 
		vertex3f_x: x  y: y z: z; 
		vertex3f_x: x+1 y: y z: z; 
		vertex3f_x: x+1 y: 0 z: z; 
		
		color3f_red: 0 green: 1 blue: 0; 
		vertex3f_x: x y: 0  z: z+1; 
		vertex3f_x: x+1 y:0  z: z+1; 
		vertex3f_x: x+1 y: y z: z+1; 
		vertex3f_x: x y: y z: z+1; 
		
		color3f_red: 1 green: 0 blue: 0;
		vertex3f_x: x+1 y: 0  z: z; 
		vertex3f_x: x+1  y: y z: z; 
		vertex3f_x: x+1 y: y  z: z+1; 
		vertex3f_x: x+1 y: 0  z: z+1; 
		
		color3f_red: 1 green: 0 blue: 1; 
		vertex3f_x: x y: 0 z: z+1; 
		vertex3f_x: x y: y z: z+1; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x y: 0 z:z; 
		
		color3f_red: 0 green: 1 blue: 1; 
		vertex3f_x: x y: 0  z:z; 
		vertex3f_x: x+1 y: 0 z: z; 
		vertex3f_x: x+1 y: 0 z: z+1; 
		vertex3f_x: x y: 0 z: z+1; 
		
		color3f_red: 1 green: 1 blue: 0; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x y: y z: z+1; 
		vertex3f_x: x+1 y: y  z: z+1; 
		vertex3f_x: x+1 y: y z: z; 
		popName;
		popMatrix;

	end.
	! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 17:05'!
initialize
	
	super initialize.
	xrot := 0.
	yrot := 0.
	zrot := 0.
	xtran := 0.
	ytran := 0.
	ztran := -50.
	znumb := 0.
	xnumb := 0.
	ynumb := 0.
	rot := 0.
	
	self on: #mouseDown send: #pickPixel: to: self.
	
"	pickingBuf := GLFrameBufferForPicking new initialize: display gl extent: display extent.
	pickingBuf createAttachments; checkStatus.
	"! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
line_x: x y: y z: z
	|gl|
	
	gl := display gl.
	
	gl begin: GL_LINES;

		color3f_red: 1 green: 0 blue: 0; 
		vertex3f_x: x y: y  z: z; 
		vertex3f_x: x+1 y: y  z: z; 

		color3f_red: 0 green: 1 blue: 0; 
		vertex3f_x: x y: y z: z; 
		vertex3f_x: x y: y+1 z: z;
		 
		color3f_red: 0 green: 0 blue: 1; 
		vertex3f_x: x y:  y z: z; 
		vertex3f_x: x y: y z: z+1;
		
	end.
	! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
openInWorld

	super openInWorld.
	
	self startStepping.! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
perspectiveFovY: fovY aspect: aspect zNear: zNear zFar: zFar
"Replaces gluPerspective. Sets the frustum to perspective mode.
// fovY     - Field of vision in degrees in the y direction
// aspect   - Aspect ratio of the viewport
// zNear    - The near clipping distance
// zFar     - The far clipping distance
 "
	| fW fH |
	fH := (fovY / (360 * Float pi)) tan * zNear.
	"fH = tan( fovY / 360 * pi ) * zNear;"
	fW := fH * aspect.
	display gl frustum_left: fW negated  right:  fW bottom: fH negated top: fH  zNear:  zNear zFar:   zFar! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 17:08'!
pickPixel: e
	| x y  pixel |
	 x := (e position x) - self position x.
	 y := (e position y) - self position y.

	pixel := display readPixel: x@y.	

	Transcript cr;show: pixel printString.
	
! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/21/2012 09:06'!
render

	| gl |
	display bindRenderBuffers.
	self checkSession.
	gl := display gl.
		
	gl 
	      enable: GL_MULTISAMPLE;
		shadeModel: GL_SMOOTH;					
		clearDepth: 1; 
	 	enable: GL_DEPTH_TEST;
		depthFunc: GL_LEQUAL;
		depthMask: true.

	gl 
		clearColor_red: 1 green:  1 blue:  1 alpha: 0;
		clear: GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT.

	
	gl matrixMode: GL_PROJECTION; 						
		loadIdentity.	
			
	self perspectiveFovY: 45.0 
			aspect: (self width /self height) asFloat 
			zNear:  0.1 zFar: 010000.0.

	gl matrixMode: GL_MODELVIEW. 						
	gl loadIdentity.	


	self applyCamera.
	gl rotatef_angle: (rot\\360) x: 1 y: 1 z: 1.
	self line_x: 0 y: 0 z: 0.
	self cube_x: 1 y: 1 z: 1.
	gl flush.
! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/19/2012 17:08'!
step
	rot := rot + 2.
	self changed! !

!GLTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/9/2012 12:34'!
stepTime
	^ 1! !

GLViewportMorph subclass: #SourceCityGL
	instanceVariableNames: 'importer configuration pickingBuf selectedElement informationDisplay camera controller drawing userInterface'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!SourceCityGL commentStamp: '<historical>' prior: 0!
A GLCity is a class which display the city with OpenGL, this class use camera and key handler!

!SourceCityGL class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 6/22/2012 15:51'!
default
	^self  new 
		default: (CityConfiguration default model: SourceCityImporter defaultModel)! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:11'!
camera
	^ camera! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:11'!
camera: anObject
	camera := anObject! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:13'!
changeConfiguration: aCityConfiguration
	configuration := aCityConfiguration.
	self importer: configuration model.! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:11'!
configuration
	^ configuration! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:11'!
configuration: anObject
	configuration := anObject! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 16:09'!
controller
	^ controller! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 16:09'!
controller: anObject
	controller := anObject! !

!SourceCityGL methodsFor: 'initialize' stamp: 'DouailleErwan 6/18/2012 16:24'!
default: aCityConfiguration
	configuration := aCityConfiguration.
	self importer: configuration model.! !

!SourceCityGL methodsFor: 'rendering' stamp: 'DouailleErwan 6/18/2012 10:24'!
disableOpenGLOption
	
	display gl 		
		disable: GL_MULTISAMPLE ;
		disable: GL_BLEND;
		disable: GL_POLYGON_SMOOTH;
		disable: GL_NORMALIZE;
		clearDepth: 1; 
	 	disable: GL_DEPTH_TEST;
		depthFunc: GL_LEQUAL;
		depthMask: true.! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/22/2012 15:39'!
display
	^ display! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/21/2012 14:01'!
drawing
	^ drawing! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/21/2012 14:01'!
drawing: anObject
	drawing := anObject! !

!SourceCityGL methodsFor: 'rendering' stamp: 'DouailleErwan 6/18/2012 11:34'!
enableOpenGLOption
	
	display gl 		
		enable: GL_MULTISAMPLE ;
		enable: GL_BLEND;
		enable: GL_POLYGON_SMOOTH;
		enable: GL_NORMALIZE;
		clearDepth: 1; 
	 	enable: GL_DEPTH_TEST;
		shadeModel: GL_SMOOTH;
		hint_target: GL_LINE_SMOOTH_HINT mode: GL_FASTEST;
		hint_target: GL_POLYGON_SMOOTH_HINT mode: GL_FASTEST;
		hint_target: GL_PERSPECTIVE_CORRECTION_HINT mode: GL_NICEST;
		depthFunc: GL_LEQUAL;
		depthMask: true.		
	"save it there for the moment :)"
	"WORK !!!!!!!!"
	"specular := GLFloatRGBA new.
	specular r: 1; g: 1;b: 1; a:1. 
	shinines:= GLFloatRGBA new.
	shinines r: 500. 	
	l_pos := GLFloatVector new.
	l_pos x: 0 ;y: 0;z: 0. 
	l_color := GLFloatRGBA new.
	l_color r: 1; g: 1;b: 1; a:1. 			
	lmodel_ambient := GLFloatRGBA new.
	lmodel_ambient r: 1;g: 1 ;b: 1; a:1."
	
	"fog_color := GLFloatRGBA new.
	fog_color r: 0.5; g: 0.5;b: 0.5; a:1. "
		
		"FOG"
		"enable: GL_FOG;
		fogi_pname: GL_FOG_MODE param: GL_EXP2;
		fogfv_pname: GL_FOG_COLOR params: fog_color;
		fogf_pname: GL_FOG_DENSITY param: 0.01;
		hint_target: GL_FOG_HINT mode: GL_DONT_CARE;
		fogf_pname: GL_FOG_START param: 1.0;
		fogf_pname: GL_FOG_END param: 5.0;"
		
		"LIGHT"
		"materialfv_face: GL_FRONT pname: GL_SPECULAR params: specular;
		materialfv_face: GL_FRONT pname: GL_SHININESS  params: shinines;
		lightfv_light: GL_LIGHT0 pname: GL_POSITION params: l_pos;
		lightfv_light: GL_LIGHT0 pname: GL_DIFFUSE params: l_color;
		lightfv_light: GL_LIGHT0 pname: GL_SPECULAR params: l_color;
		lightModelfv_pname: GL_LIGHT_MODEL_AMBIENT params: lmodel_ambient;
		enable: GL_LIGHTING;
		enable: GL_LIGHT0;	"
				
	! !

!SourceCityGL methodsFor: 'events-handling' stamp: 'DouailleErwan 6/20/2012 11:24'!
handleMouseMove: anEvent
	self controller handleMouseMove: anEvent
! !

!SourceCityGL methodsFor: 'events-handling' stamp: 'DouailleErwan 6/20/2012 11:37'!
handlesMouseOver: anEvent
	^ true! !

!SourceCityGL methodsFor: 'events-handling' stamp: 'DouailleErwan 6/20/2012 11:37'!
hasKeyboardFocus
	^true.! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:12'!
importer
	^ importer! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:12'!
importer: anObject
	importer := anObject! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:11'!
informationDisplay
	^ informationDisplay! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:11'!
informationDisplay: anObject
	informationDisplay := anObject! !

!SourceCityGL methodsFor: 'initialize' stamp: 'DouailleErwan 6/24/2012 14:09'!
initialize
	| fontPath |
	super initialize.
	
	self camera: (SourceCityGLCamera initialize: self).
	self controller: (SourceCityGLController initialize: self).
	self drawing: (SourceCityGLDrawing initialize: self).
	self userInterface: (SourceCityUI initialize: self).
	
	self on: #keyStroke send: #captureKey: to: self controller.
	self on: #mouseDown send: #captureMouseDown: to: self controller.	
		
	! !

!SourceCityGL methodsFor: 'events-handling' stamp: 'DouailleErwan 6/20/2012 11:37'!
mouseEnter: anEvent
	anEvent hand newKeyboardFocus: self! !

!SourceCityGL methodsFor: 'events-handling' stamp: 'DouailleErwan 6/20/2012 11:37'!
mouseLeave: anEvent
	anEvent hand newKeyboardFocus: nil! !

!SourceCityGL methodsFor: 'initialize' stamp: 'DouailleErwan 6/25/2012 10:30'!
openInWorld
	|dock container win |
	self startStepping.
	self takeKeyboardFocus.
	self userInterface openInWorld.! !

!SourceCityGL methodsFor: 'rendering' stamp: 'DouailleErwan 6/18/2012 10:24'!
openglOption: aBoolean
	(aBoolean)
	ifTrue: [self enableOpenGLOption] 
	ifFalse: [self disableOpenGLOption]. ! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:11'!
pickingBuf
	^ pickingBuf! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:11'!
pickingBuf: anObject
	pickingBuf := anObject! !

!SourceCityGL methodsFor: 'rendering' stamp: 'DouailleErwan 6/22/2012 14:31'!
render
	| gl |
	display bindRenderBuffers.
	self checkSession.
	self openglOption: true.
	gl := display gl.
	gl clearColor_red: configuration glBackground red green:  configuration glBackground green blue:  configuration glBackground blue alpha: 0;
		clear: GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT;
		matrixMode: GL_PROJECTION; 						
		loadIdentity.		
			
	self camera perspectiveFovY: 100.0  
		aspect: (self width /self height) asFloat  
		zNear: 0.1  
		zFar: 10000.0.
		
	gl matrixMode: GL_MODELVIEW; 
		loadIdentity.	
	self camera applyCamera.
	self drawing drawCity: self importer.
	gl flush.! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:11'!
selectedElement
	^ selectedElement! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:11'!
selectedElement: anObject
	selectedElement := anObject! !

!SourceCityGL methodsFor: 'stepping and presenter' stamp: 'DouailleErwan 6/18/2012 10:24'!
step
	self changed! !

!SourceCityGL methodsFor: 'stepping and presenter' stamp: 'DouailleErwan 6/18/2012 10:24'!
stepTime
	^5! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/24/2012 14:08'!
userInterface
	^ userInterface! !

!SourceCityGL methodsFor: 'accessing' stamp: 'DouailleErwan 6/24/2012 14:08'!
userInterface: anObject
	userInterface := anObject! !

GLViewportMorph subclass: #SourceCityGLDrawing
	instanceVariableNames: 'pickingMode sourceCityGL'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!SourceCityGLDrawing commentStamp: '<historical>' prior: 0!
I manage how do render the city.!

!SourceCityGLDrawing class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 6/21/2012 13:57'!
initialize: aSourceCityGL
	^self new sourceCityGL: aSourceCityGL! !

!SourceCityGLDrawing methodsFor: 'drawing' stamp: 'DouailleErwan 6/23/2012 11:51'!
building: aBuilding array: anArray width: width
	| x z y r g b id |
	(self pickingMode)
	ifTrue: [
		id := aBuilding id.
		r := id bitAnd: 255.
		g := id >> 8 bitAnd: 255.  " id // (2^8) "
		b := id >>16 bitAnd: 255.
		display gl color3ub_red:  r green: g  blue:  b.
		] 
	ifFalse: [
		(self selectedElement = aBuilding)
		ifTrue: [display gl color3f_red: 255 green: 255 blue: 255] 
		ifFalse: [display gl color3f_red: aBuilding color red green: aBuilding color green blue: aBuilding color blue.].
		].
	
	self drawBuilding: anArray width: width.
	
	(self pickingMode)
	ifFalse: [self drawBorder: anArray width: width.].! !

!SourceCityGLDrawing methodsFor: 'drawing' stamp: 'DouailleErwan 6/22/2012 15:38'!
city: anArrayStart to: anArrayEnd color: aColor
	|gl|
	gl := display gl.	
	gl begin: GL_QUADS;
		color3f_red: aColor red green: aColor green blue: aColor blue; 
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayStart third;
		vertex3d_x: anArrayEnd first y: anArrayStart second z: anArrayEnd third;
		vertex3d_x: anArrayStart first y: anArrayStart second z: anArrayEnd third;
	end.
	! !

!SourceCityGLDrawing methodsFor: 'drawing' stamp: 'DouailleErwan 6/21/2012 16:22'!
district: aDistrict array: anArray x_width: axWidthSelector z_width: azWidthSelector
	| x z y r g b id |
	(self pickingMode)
	ifTrue: [
		id := aDistrict id.
		r := id bitAnd: 255.
		g := id >> 8 bitAnd: 255.  " id // (2^8) "
		b := id >>16 bitAnd: 255.
		display gl color3ub_red:  r green: g  blue:  b.
		] 
	ifFalse: [
		(self selectedElement = aDistrict)
		ifTrue: [display gl color3f_red: 255 green: 255 blue: 255] 
		ifFalse: [display gl color3f_red: self sourceCityGL configuration districtColor red green: self sourceCityGL configuration districtColor green blue: self sourceCityGL configuration districtColor blue.].
		].
		
	"self drawFace: anArray width: axWidthSelector.
	self drawBack: anArray width: axWidthSelector.
	self drawLeft: anArray width: azWidthSelector.
	self drawRight: anArray width: azWidthSelector".
	self drawDown: anArray width: axWidthSelector.
	"self drawTop: anArray width: azWidthSelector."! !

!SourceCityGLDrawing methodsFor: 'draw-polygon' stamp: 'DouailleErwan 6/20/2012 14:28'!
drawBack: anArray width: aWidthSelector
	|gl x z y |
	gl := display gl.
	gl begin: GL_QUADS;
		vertex3d_x:  anArray first y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3d_x:  (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3d_x:  (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		vertex3d_x:  anArray first y: anArray second z: (anArray third)+aWidthSelector;
	end.! !

!SourceCityGLDrawing methodsFor: 'draw-polygon' stamp: 'DouailleErwan 6/20/2012 14:28'!
drawBorder: anArray width: aWidthSelector
	|gl|
	gl := display gl.
	gl begin: GL_LINES;

		color3f_red: 0 green: 0 blue: 0; 
		vertex3f_x: anArray first y: 0.1 z: anArray third;
		vertex3f_x: anArray first y: anArray second z: anArray third;
		
		vertex3f_x: anArray first y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3f_x: anArray first y: anArray second z: (anArray third)+aWidthSelector;
		
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: anArray third;
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: anArray third;
		
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		
		vertex3f_x: anArray first y: 0.1 z: anArray third;
		vertex3f_x: anArray first y: 0.1 z: (anArray third)+aWidthSelector;
		
		vertex3f_x: anArray first y: anArray second z: anArray third;
		vertex3f_x: anArray first y: anArray second z: (anArray third)+aWidthSelector;
		
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: anArray third;
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: anArray third;
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
		
		vertex3f_x: anArray first y: anArray second z: anArray third;
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: anArray third;
		
		vertex3f_x: anArray first y: 0.1 z: anArray third;
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: anArray third;
		
		vertex3f_x: anArray first y: anArray second z: (anArray third)+aWidthSelector;
		vertex3f_x: (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		
		vertex3f_x: anArray first y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3f_x: (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
		
	end.! !

!SourceCityGLDrawing methodsFor: 'drawing' stamp: 'DouailleErwan 6/21/2012 15:05'!
drawBuilding: aDistrict gap: buildingGap x: x z: z dxSize: dxSize
	| bxSize bzSize zmax buildingColor |
	bxSize := x +1 .
	bzSize := z +1.
	zmax := 0.
	aDistrict buildings do: [:building |
		(dxSize < (bxSize+ (building width)))
		ifTrue: [
			bzSize := bzSize + zmax + buildingGap.
			bxSize := x + 1.
			].
		(zmax<(building width))
		ifTrue:[zmax := (building width)].
		self building: building array: { bxSize . (building height) . bzSize } width: (building width) .
		bxSize := bxSize + buildingGap + (building width).
	].
	^bzSize+zmax+1.! !

!SourceCityGLDrawing methodsFor: 'draw-polygon' stamp: 'DouailleErwan 6/23/2012 11:50'!
drawBuilding: anArray width: width
	self drawFace: anArray width: width.
	self drawBack: anArray width: width.
	self drawLeft: anArray width: width.
	self drawRight: anArray width: width.
	self drawDown: anArray width: width.
	self drawTop: anArray width: width.! !

!SourceCityGLDrawing methodsFor: 'drawing' stamp: 'DouailleErwan 6/23/2012 11:48'!
drawCity: anImporter
	| cityColor |
	(self pickingMode)
	ifTrue: [cityColor := Color black] 
	ifFalse: [cityColor := sourceCityGL configuration cityColor].
	self city: {-1 . -0.1 . -1} 
		to: (self drawDistrict: anImporter city gap: self sourceCityGL configuration districtGap) 
		color: cityColor! !

!SourceCityGLDrawing methodsFor: 'drawing' stamp: 'DouailleErwan 6/21/2012 15:38'!
drawDistrict:aCity gap: gap
	| dxSize x dzSize z maxdxSize maxdzSize bxSize bzSize buildingGap districtColor |
	x := 0.
	z := 0.
	buildingGap := self sourceCityGL configuration buildingGap.
	(self sourceCityGL configuration buildingGap < 1)
	ifTrue: [buildingGap := 1.] 
	ifFalse: [buildingGap := self sourceCityGL configuration buildingGap].
	maxdzSize := 0.
	maxdxSize := 0.
	aCity districts do:[:district |
		dxSize := x + ((district width) *buildingGap+1).
		dzSize := self drawBuilding: district gap: buildingGap x: x z: z dxSize: dxSize.
		self district: district array: {x . 0.1 . z} x_width: dxSize-x z_width: dzSize.
		(maxdzSize < dzSize)
		ifTrue: [ maxdzSize := dzSize].
		x := dxSize + gap.
		( x > aCity width)
		ifTrue: [
			z := maxdzSize + gap.
			(maxdxSize<x)
			ifTrue: [maxdxSize := x+(dxSize - x).].
			x := 0.
		]
		ifFalse: [
			(maxdxSize<x)
			ifTrue: [maxdxSize := x.].
		].
	].
	^{maxdxSize+1 . 0 . maxdzSize+1}! !

!SourceCityGLDrawing methodsFor: 'draw-polygon' stamp: 'DouailleErwan 6/20/2012 14:28'!
drawDown: anArray width: aWidthSelector
	| gl x z y |
	gl := display gl.
	gl enable: GL_NORMALIZE .
	gl begin: GL_QUADS;
		vertex3d_x:  anArray first y: 0.1 z: anArray third;
		vertex3d_x:  (anArray first)+aWidthSelector y: 0.1 z: anArray third;
		vertex3d_x:  (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3d_x:  anArray first y: 0.1 z: (anArray third)+aWidthSelector;
	end.! !

!SourceCityGLDrawing methodsFor: 'draw-polygon' stamp: 'DouailleErwan 6/22/2012 15:39'!
drawFace: anArray width: aWidthSelector
	| gl x z y |
	gl := display gl.
	gl begin: GL_QUADS;
		vertex3d_x: anArray first y: 0.1 z: anArray third;
		vertex3d_x: anArray first y: anArray second z: anArray third;
		vertex3d_x: (anArray first)+aWidthSelector y: anArray second z: anArray third;
		vertex3d_x: (anArray first)+aWidthSelector y: 0.1 z: anArray third;
	end.! !

!SourceCityGLDrawing methodsFor: 'draw-polygon' stamp: 'DouailleErwan 6/20/2012 14:28'!
drawLeft: anArray width: aWidthSelector
	| gl x z y |
	gl := display gl.
	gl begin: GL_QUADS;
		vertex3d_x:  (anArray first)+aWidthSelector y: 0.1 z: anArray third;
		vertex3d_x:  (anArray first)+aWidthSelector y: anArray second z: anArray third;
		vertex3d_x:  (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		vertex3d_x:  (anArray first)+aWidthSelector y: 0.1 z: (anArray third)+aWidthSelector;
	end.! !

!SourceCityGLDrawing methodsFor: 'draw-polygon' stamp: 'DouailleErwan 6/20/2012 14:28'!
drawRight: anArray width: aWidthSelector
	| gl x z y |
	gl := display gl.
	gl begin: GL_QUADS;
		vertex3d_x:  anArray first y: 0.1 z: (anArray third)+aWidthSelector;
		vertex3d_x:  anArray first y: anArray second z: (anArray third)+aWidthSelector;
		vertex3d_x:  anArray first y: anArray second z: anArray third ;
		vertex3d_x:  anArray first y: 0.1 z: anArray third ;
	end.! !

!SourceCityGLDrawing methodsFor: 'draw-polygon' stamp: 'DouailleErwan 6/20/2012 14:28'!
drawTop: anArray width: aWidthSelector
	|gl x z y |
	gl := display gl.
	gl begin: GL_QUADS;
		vertex3d_x: anArray first y: anArray second z: anArray third ;
		vertex3d_x: anArray first y: anArray second z: (anArray third)+aWidthSelector;
		vertex3d_x: (anArray first)+aWidthSelector y: anArray second z: (anArray third)+aWidthSelector;
		vertex3d_x: (anArray first)+aWidthSelector y: anArray second z: anArray third ;
	end.! !

!SourceCityGLDrawing methodsFor: 'initialize' stamp: 'DouailleErwan 6/21/2012 14:35'!
initialize
	super initialize.
	self pickingMode: false.
	! !

!SourceCityGLDrawing methodsFor: 'accessing' stamp: 'DouailleErwan 6/21/2012 14:07'!
pickingMode
	^ pickingMode! !

!SourceCityGLDrawing methodsFor: 'accessing' stamp: 'DouailleErwan 6/21/2012 14:07'!
pickingMode: anObject
	pickingMode := anObject! !

!SourceCityGLDrawing methodsFor: 'accessing' stamp: 'DouailleErwan 6/21/2012 16:23'!
selectedElement
	^ self sourceCityGL selectedElement! !

!SourceCityGLDrawing methodsFor: 'accessing' stamp: 'DouailleErwan 6/22/2012 13:22'!
selectedElement: anObject
	^ self sourceCityGL selectedElement: anObject! !

!SourceCityGLDrawing methodsFor: 'accessing' stamp: 'DouailleErwan 6/21/2012 14:08'!
sourceCityGL
	^ sourceCityGL! !

!SourceCityGLDrawing methodsFor: 'accessing' stamp: 'DouailleErwan 6/21/2012 14:08'!
sourceCityGL: anObject
	sourceCityGL := anObject! !

!NBMSAAOffscreenDisplay methodsFor: '*SourceCity-OpenGL' stamp: 'DouailleErwan 5/22/2012 11:35'!
readPixel: aPoint
	| r |

	renderFBO bindAsReadBuffer.
	resultsFBO bindAsDrawBuffer.
	
	self gl blitFramebuffer_srcX0: 0 srcY0:  0 srcX1: extent x srcY1: extent y 
		dstX0:  0 dstY0:  0 dstX1: extent x  dstY1: extent y mask: GL_COLOR_BUFFER_BIT filter: GL_NEAREST.
	
	resultsFBO bindAsReadBuffer.
		
	r := super readPixel: aPoint.
	^ r! !

Object subclass: #SourceCityGLCamera
	instanceVariableNames: 'xtran ytran ztran lastMousePosition sourceCityGL'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!SourceCityGLCamera commentStamp: '<historical>' prior: 0!
I manage the camera and movements (do not contains key/mouse handler stuff)!

!SourceCityGLCamera class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 6/20/2012 09:47'!
initialize: aSourceCityGL
	^self new sourceCityGL: aSourceCityGL.
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/20/2012 11:58'!
applyCamera
	 self sourceCityGL display gl translatef_x: self xtran y: self ytran z: self ztran.  
	 self sourceCityGL display gl  rotatef_angle:  self sourceCityGL configuration cameraXPos x: 1 y: 0  z: 0. 
	 self sourceCityGL display gl rotatef_angle:  self sourceCityGL configuration cameraYPos x: 0 y: 1  z: 0. 
	 self sourceCityGL display gl rotatef_angle:  self sourceCityGL configuration cameraZPos x: 0 y: 0  z: 1. 
	 
! !

!SourceCityGLCamera methodsFor: 'initialize' stamp: 'DouailleErwan 6/20/2012 14:05'!
initialize
	lastMousePosition := Point x: 0 y:0.
	xtran := 0.
	ytran := 30.
	ztran := -184.
	! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 13:57'!
lastMousePosition
	^lastMousePosition ! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 13:53'!
lastMousePosition: aPoint
	lastMousePosition := aPoint! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/22/2012 15:39'!
perspectiveFovY: fovY aspect: aspect zNear: zNear zFar: zFar
"Replaces gluPerspective. Sets the frustum to perspective mode.
// fovY     - Field of vision in degrees in the y direction
// aspect   - Aspect ratio of the viewport
// zNear    - The near clipping distance
// zFar     - The far clipping distance
 "
	| fW fH |
	fH := (fovY / (360 * Float pi)) tan * zNear.
	fW := fH * aspect.
	self sourceCityGL display gl frustum_left: fW negated  right:  fW bottom: fH negated top: fH  zNear:  zNear zFar:   zFar! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/18/2012 14:56'!
rotateDown

	self sourceCityGL configuration cameraXPos: (self sourceCityGL configuration cameraXPos + 3).
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/18/2012 14:56'!
rotateLeft

	self sourceCityGL configuration cameraYPos: (self sourceCityGL configuration cameraYPos + 3).
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/18/2012 14:56'!
rotateRight
	
	self sourceCityGL configuration cameraYPos: (self sourceCityGL configuration cameraYPos - 3).! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/18/2012 14:56'!
rotateTop
	self sourceCityGL configuration cameraXPos: (self sourceCityGL configuration cameraXPos - 3).! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 14:55'!
sourceCityGL
	^ sourceCityGL! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 14:55'!
sourceCityGL: anObject
	sourceCityGL := anObject! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/18/2012 14:56'!
translateBackward

	self ztran: (self ztran - 10).
	
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/18/2012 14:56'!
translateDown

	self ytran: (self ytran + 10).
	
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/18/2012 14:57'!
translateForward

	self ztran: (self ztran + 10).
	
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/18/2012 14:57'!
translateLeft

	self xtran: (self xtran - 10).
	
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/18/2012 14:57'!
translateRight

	self xtran: (self xtran + 10).
	
	! !

!SourceCityGLCamera methodsFor: 'camera' stamp: 'DouailleErwan 6/18/2012 14:57'!
translateTop

	self ytran: (self ytran - 10).
	
	! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 14:55'!
xtran
	^ xtran! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 14:55'!
xtran: anObject
	xtran := anObject! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 14:55'!
ytran
	^ ytran! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 14:55'!
ytran: anObject
	ytran := anObject! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 14:55'!
ztran
	^ ztran! !

!SourceCityGLCamera methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 14:55'!
ztran: anObject
	ztran := anObject! !

Object subclass: #SourceCityGLController
	instanceVariableNames: 'sourceCityGL'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!SourceCityGLController commentStamp: '<historical>' prior: 0!
I manage and capture keyboard and mouse events!

!SourceCityGLController class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 6/21/2012 13:03'!
initialize: aSourceCityGL
	^self new sourceCityGL: aSourceCityGL! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 6/20/2012 11:53'!
captureKey: e
	(e keyString = '<left>')
		ifTrue:[ self sourceCityGL camera rotateLeft].
	(e keyString  = '<down>')
		ifTrue:[self sourceCityGL camera rotateDown].
	(e keyString  = '<up>')
		ifTrue:[self sourceCityGL camera rotateTop].
	(e keyString  = '<right>')
		ifTrue:[self sourceCityGL camera rotateRight].
	(e keyString  = '<Shift-right>')
		ifTrue:[self sourceCityGL camera translateRight].
	(e keyString  = '<Shift-left>')
		ifTrue:[self sourceCityGL camera translateLeft].
	(e keyString  = '<Shift-up>')
		ifTrue:[self sourceCityGL camera translateTop].
	(e keyString  = '<Shift-down>')
		ifTrue:[self sourceCityGL camera translateDown].
	(e keyString  = ' ')
		ifTrue:[self sourceCityGL camera translateForward].
	(e keyString  = 'c' )
		ifTrue:[self sourceCityGL camera translateBackward].
	(e keyString  = '<Cmd-w>' )
		ifTrue:[Transcript cr;show: ' =no !!!!!! don t leave please .... ah ah you can t for the moment :p '].! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 6/22/2012 15:19'!
captureMouseDown: e
	self sourceCityGL drawing pickingMode: true.
	self sourceCityGL drawing drawCity: self sourceCityGL importer.
	self picking_x: ((e position x) - self sourceCityGL position x) y: ((e position y) - self sourceCityGL position y).
	self sourceCityGL drawing pickingMode: false.! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 6/20/2012 11:44'!
captureMouseStillDown: e
	(self sourceCityGL camera  lastMousePosition x > (e position - self sourceCityGL position) x)
		ifTrue: [self sourceCityGL camera  rotateLeft].
	(self sourceCityGL camera  lastMousePosition x < (e position - self sourceCityGL  position) x)
		ifTrue:[self sourceCityGL camera  rotateRight].
	(self sourceCityGL camera  lastMousePosition y < (e position - self sourceCityGL position) y)
		ifTrue:[self sourceCityGL camera  rotateTop].
	(self sourceCityGL camera  lastMousePosition y > (e position - self sourceCityGL position) y)
		ifTrue:[self sourceCityGL camera  rotateDown].
	self sourceCityGL camera  lastMousePosition: (e position - self sourceCityGL position).! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 6/22/2012 15:29'!
handleMouseMove: anEvent
	"System level event handling."
	anEvent wasHandled ifTrue:[^self]. "not interested"
	anEvent wasHandled: true.
	anEvent anyButtonPressed ifTrue: [
		self captureMouseStillDown: anEvent
		].
! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 6/18/2012 15:26'!
hasKeyboardFocus
	^true.! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 6/22/2012 15:21'!
picking_x: x y: y
	|  pixel tmp |
	pixel := self sourceCityGL display readPixel: x@y.	
	tmp := (pixel at:1)*256 + (pixel at:2)*256 + (pixel at:3).
	(tmp = 0)
	ifTrue: [self sourceCityGL selectedElement: nil] 
	ifFalse: [self sourceCityGL selectedElement: (self searchPickingInformation: tmp)].! !

!SourceCityGLController methodsFor: 'control' stamp: 'DouailleErwan 6/22/2012 15:15'!
searchPickingInformation: aValue
	| informationDisplay |
	self sourceCityGL importer districts at: aValue 
		ifPresent: [ ^ self sourceCityGL importer districts at: aValue].
	self sourceCityGL importer buildings at: aValue 
		ifPresent: [ ^self sourceCityGL importer buildings at: aValue.] .
	^nil! !

!SourceCityGLController methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:39'!
sourceCityGL
	^ sourceCityGL! !

!SourceCityGLController methodsFor: 'accessing' stamp: 'DouailleErwan 6/18/2012 15:39'!
sourceCityGL: anObject
	sourceCityGL := anObject! !

NBGLFrameBuffer subclass: #GLFrameBufferForPicking
	instanceVariableNames: 'texId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-OpenGL'!

!GLFrameBufferForPicking methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 15:39'!
attachTexture
	texId := WordArray new: 1.
	
" Create the texture object for the primitive information buffer "
	gl genTextures_n: 1 textures: texId.
	texId := texId at: 1.

	gl bindTexture_target: GL_TEXTURE_2D texture: texId.

	gl texImage2D_target:  GL_TEXTURE_2D level: 0  internalformat:  GL_RGB32UI 
		width: extent x  height: extent y border: 0  format: GL_RGB_INTEGER type: GL_UNSIGNED_INT pixels: nil.
	
	gl framebufferTexture2DEXT_target:  GL_DRAW_FRAMEBUFFER 
		attachment:  GL_COLOR_ATTACHMENT0 
		textarget: GL_TEXTURE_2D 
		texture:  texId  
		level: 0	.
	
	self assert: (gl getError = 0).
	gl bindTexture_target: GL_TEXTURE_2D texture: 0.! !

!GLFrameBufferForPicking methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 15:21'!
createAttachments

		" By default, create a RGBA8 and DEPTH24/STENCIL8 attachments "
	| color depthAndStencil |
	
	self attachTexture.

	
	depthAndStencil := NBGLRenderBuffer gl: gl extent: extent format: GL_DEPTH24_STENCIL8.
	self attach: depthAndStencil as: GL_DEPTH_ATTACHMENT.
	self attach: depthAndStencil as: GL_STENCIL_ATTACHMENT.
	
! !

!GLFrameBufferForPicking methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 15:23'!
resize: newExtent

	"resize a frame buffer"
	extent = newExtent ifTrue: [ ^ self ].
	extent := newExtent.	

	self attachments do: [:renderBuffer | renderBuffer resize: newExtent  ].
	self resizeTexture.
	self checkStatus.

! !

!GLFrameBufferForPicking methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/16/2012 15:23'!
resizeTexture

	gl bindTexture_target: GL_TEXTURE_2D texture: texId.

	gl texImage2D_target:  GL_TEXTURE_2D level: 0  internalformat:  GL_RGB32UI 
		width: extent x  height: extent y border: 0  format: GL_RGB_INTEGER type: GL_UNSIGNED_INT pixels: nil.
! !
